# git-fetch(1) Manual Page

## NAME

git-fetch - Download objects and refs from another repository

## SYNOPSIS

git-fetch <options> <repository> <refspec>…

## DESCRIPTION

Fetches named heads or tags from another repository, along with the objects necessary to complete them.

The ref names and their object names of fetched refs are stored in `.git/FETCH_HEAD`. This information is left for a later merge operation done by "git merge".

When <refspec> stores the fetched result in tracking branches, the tags that point at these branches are automatically followed. This is done by first fetching from the remote using the given <refspec>s, and if the repository has objects that are pointed by remote tags that it does not yet have, then fetch those missing tags. If the other end has tags that point at branches you are not interested in, you will not get them.

## OPTIONS

-q, --quiet

  Pass --quiet to git-fetch-pack and silence any other internally used programs.

-v, --verbose

  Be verbose.

-a, --append

  Append ref names and object names of fetched refs to the existing contents of `.git/FETCH_HEAD`. Without this option old data in `.git/FETCH_HEAD` will be overwritten.

--upload-pack <upload-pack>

  When given, and the repository to fetch from is handled by git-fetch-pack, --exec=<upload-pack> is passed to the command to specify non-default path for the command run on the other end.

-f, --force

  When `git-fetch` is used with `<rbranch>:<lbranch>` refspec, it refuses to update the local branch `<lbranch>` unless the remote branch `<rbranch>` it fetches is a descendant of `<lbranch>`. This option overrides that check.

-n, --no-tags

  By default, tags that point at objects that are downloaded from the remote repository are fetched and stored locally. This option disables this automatic tag following.

-t, --tags

  Most of the tags are fetched automatically as branch heads are downloaded, but tags that do not point at objects reachable from the branch heads that are being tracked will not be fetched by this mechanism. This flag lets all tags and their associated objects be downloaded.

-k, --keep

  Keep downloaded pack.

-u, --update-head-ok

  By default `git-fetch` refuses to update the head which corresponds to the current branch. This flag disables the check. This is purely for the internal use for `git-pull` to communicate with `git-fetch`, and unless you are implementing your own Porcelain you are not supposed to use it.

--depth=<depth>

  Deepen the history of a shallow repository created by `git clone` with `--depth=<depth>` option (see git-clone(1)) by the specified number of commits.

<repository>

  The "remote" repository that is the source of a fetch or pull operation. See the section GIT URLS below.

<refspec>

  The canonical format of a <refspec> parameter is `+?<src>:<dst>`; that is, an optional plus `+`, followed by the source ref, followed by a colon `:`, followed by the destination ref.

  The remote ref that matches <src> is fetched, and if <dst> is not empty string, the local ref that matches it is fast forwarded using <src>. Again, if the optional plus `+` is used, the local ref is updated even if it does not result in a fast forward update.

  Note | If the remote branch from which you want to pull is modified in non-linear ways such as being rewound and rebased frequently, then a pull will attempt a merge with an older version of itself, likely conflict, and fail. It is under these conditions that you would want to use the `+` sign to indicate non-fast-forward updates will be needed. There is currently no easy way to determine or declare that a branch will be made available in a repository with this behavior; the pulling user simply must know this is the expected usage pattern for a branch.

  Note | You never do your own development on branches that appear on the right hand side of a <refspec> colon on `Pull:` lines; they are to be updated by `git-fetch`. If you intend to do development derived from a remote branch `B`, have a `Pull:` line to track it (i.e. `Pull: B:remote-B`), and have a separate branch `my-B` to do your development on top of it. The latter is created by `git branch my-B remote-B` (or its equivalent `git checkout -b my-B remote-B`). Run `git fetch` to keep track of the progress of the remote side, and when you see something new on the remote branch, merge it into your development branch with `git pull . remote-B`, while you are on `my-B` branch.

  Note | There is a difference between listing multiple <refspec> directly on `git-pull` command line and having multiple `Pull:` <refspec> lines for a <repository> and running `git-pull` command without any explicit <refspec> parameters. <refspec> listed explicitly on the command line are always merged into the current branch after fetching. In other words, if you list more than one remote refs, you would be making an Octopus. While `git-pull` run without any explicit <refspec> parameter takes default <refspec>s from `Pull:` lines, it merges only the first <refspec> found into the current branch, after fetching all the remote refs. This is because making an Octopus from remote refs is rarely done, while keeping track of multiple remote heads in one-go by fetching more than one is often useful.

  Some short-cut notations are also supported.

  - `tag <tag>` means the same as `refs/tags/<tag>:refs/tags/<tag>`; it requests fetching everything up to the given tag.

  - A parameter <ref> without a colon is equivalent to <ref>: when pulling/fetching, so it merges <ref> into the current branch without storing the remote branch anywhere locally

## GIT URLS

One of the following notations can be used to name the remote repository:

- rsync://host.xz/path/to/repo.git/

- http://host.xz/path/to/repo.git/

- https://host.xz/path/to/repo.git/

- git://host.xz/path/to/repo.git/

- git://host.xz/~user/path/to/repo.git/

- ssh://[user@]host.xz[:port]/path/to/repo.git/

- ssh://[user@]host.xz/path/to/repo.git/

- ssh://[user@]host.xz/~user/path/to/repo.git/

- ssh://[user@]host.xz/~/path/to/repo.git

SSH is the default transport protocol over the network. You can optionally specify which user to log-in as, and an alternate, scp-like syntax is also supported. Both syntaxes support username expansion, as does the native git protocol, but only the former supports port specification. The following three are identical to the last three above, respectively:

- [user@]host.xz:/path/to/repo.git/

- [user@]host.xz:~user/path/to/repo.git/

- [user@]host.xz:path/to/repo.git

To sync with a local directory, you can use:

- /path/to/repo.git/

- file:///path/to/repo.git/

They are mostly equivalent, except when cloning. See git-clone(1) for details.

## REMOTES

In addition to the above, as a short-hand, the name of a file in `$GIT_DIR/remotes` directory can be given; the named file should be in the following format:

            URL: one of the above URL format
            Push: <refspec>
            Pull: <refspec>

Then such a short-hand is specified in place of <repository> without <refspec> parameters on the command line, <refspec> specified on `Push:` lines or `Pull:` lines are used for `git-push` and `git-fetch`/`git-pull`, respectively. Multiple `Push:` and `Pull:` lines may be specified for additional branch mappings.

Or, equivalently, in the `$GIT_DIR/config` (note the use of `fetch` instead of `Pull:`):

            [remote "<remote>"]
                    url = <url>
                    push = <refspec>
                    fetch = <refspec>

The name of a file in `$GIT_DIR/branches` directory can be specified as an older notation short-hand; the named file should contain a single line, a URL in one of the above formats, optionally followed by a hash `#` and the name of remote head (URL fragment notation). `$GIT_DIR/branches/<remote>` file that stores a <url> without the fragment is equivalent to have this in the corresponding file in the `$GIT_DIR/remotes/` directory.

            URL: <url>
            Pull: refs/heads/master:<remote>

while having `<url>#<head>` is equivalent to

            URL: <url>
            Pull: refs/heads/<head>:<remote>

## SEE ALSO

git-pull(1)

## Author

Written by Linus Torvalds <torvalds@osdl.org> and Junio C Hamano <junkio@cox.net>

## Documentation

Documentation by David Greaves, Junio C Hamano and the git-list <git@vger.kernel.org>.

## GIT

Part of the git(7) suite